package wusthelper.web.api.v2.dto.response.library;

import cn.wustlinghang.mywust.data.library.origin.BookSearchResult;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.Data;

import java.util.Arrays;

@Data
@JsonInclude(JsonInclude.Include.NON_NULL)
public class BookSearchResponseItem {
    /**
     * 书名
     */
    private String title;

    /**
     * 作者
     */
    private String author;

    /**
     * 发布时间
     */
    private String pubYear;

    /**
     * 出版方
     */
    private String publisher;

    /**
     * 索书号
     */
    private String callNo;

    /**
     * 书籍详情URL
     */
    private String detailUrl;

    /**
     * 图片URL
     */
    private String imgUrl;

    /**
     * 馆藏总数
     */
    private String allNum;

    /**
     * 可借数目
     */
    private String remainNum;

    private String isbn;

    @JsonInclude(JsonInclude.Include.NON_NULL)
    public static BookSearchResponseItem from(BookSearchResult bookSearchResult) {
        BookSearchResponseItem bookSearchResponseItem = new BookSearchResponseItem();
        bookSearchResponseItem.setTitle(bookSearchResult.getTitle());
        bookSearchResponseItem.setAuthor(bookSearchResult.getAuthor());
        bookSearchResponseItem.setPubYear(bookSearchResult.getPubYear());
        bookSearchResponseItem.setPublisher(bookSearchResult.getPublisher());

        var callNumberString = Arrays.toString(bookSearchResult.getCallNumber().toArray(new String[0]));
        bookSearchResponseItem.setCallNo(callNumberString);

        bookSearchResponseItem.setIsbn(bookSearchResult.getIsbn());
//        bookSearchResponseItem.setDetailUrl();
//        bookSearchResponseItem.setImgUrl();
//        bookSearchResponseItem.setAllNum();
//        bookSearchResponseItem.setRemainNum();

        return bookSearchResponseItem;
    }
}
