package wusthelper.web.api.v2.dto.response.library;

import cn.wustlinghang.mywust.data.library.origin.HistoryLoanBook;
import lombok.Data;

@Data
public class RentHistoryResponse {
    private String bookCode;
    private String bookPlace;
    private String bookAuthor;
    private String bookUrl;
    private String rentTime;
    private String bookName;
    private String returnTime;

    private static final String bookUrlFormat = "https://libsys.wust.edu.cn/meta-local/opac/bibs/%s/infos";

    public static RentHistoryResponse from(HistoryLoanBook historyLoanBook) {
        RentHistoryResponse currentRentResponse = new RentHistoryResponse();
        currentRentResponse.setBookCode(historyLoanBook.getBarCode());
        currentRentResponse.setBookPlace(historyLoanBook.getLocation());
        currentRentResponse.setBookUrl(bookUrlFormat.formatted(historyLoanBook.getBibId()));
        currentRentResponse.setRentTime(historyLoanBook.getLoanDate());
        currentRentResponse.setBookName(historyLoanBook.getTitle());
        currentRentResponse.setReturnTime(historyLoanBook.getReturnDate());

        return currentRentResponse;
    }
}