package wusthelper.web.api.v2.dto.response.physics;

import cn.wustlinghang.mywust.data.physics.PhysicsCourse;
import lombok.Data;
import wusthelper.web.util.GlobalLogger;

import java.sql.Date;
import java.text.SimpleDateFormat;

@Data
public class PhysicsCourseResponse {
    private String courseName;

    private String teacherName;

    private Integer week;

    private Integer weekDay;

    private Date courseDate;

    private Integer startSection;

    private Integer endSection;

    private String buildingName;

    private String areaNum;

    private String roomNum;

    private String campusName;

    public static PhysicsCourseResponse from(PhysicsCourse course) {
        PhysicsCourseResponse physicsCourseResponse = new PhysicsCourseResponse();
        physicsCourseResponse.setCourseName(course.getName());
        physicsCourseResponse.setTeacherName(course.getTeacher());
        physicsCourseResponse.setWeek(course.getStartWeek());
        physicsCourseResponse.setWeekDay(course.getWeekDay());
        physicsCourseResponse.setStartSection(course.getStartSection());
        physicsCourseResponse.setEndSection(course.getEndSection());

        try {
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
            java.util.Date parseDate = formatter.parse(course.getDate());
            physicsCourseResponse.setCourseDate(new java.sql.Date(parseDate.getTime()));
        } catch (Exception e) {
            GlobalLogger.log.error("物理实验课程解析错误，{}", e.getMessage());
            GlobalLogger.log.debug("", e);
        }

        var place = course.getClassroom();
        physicsCourseResponse.setBuildingName(place.getBuilding());
        physicsCourseResponse.setAreaNum(place.getArea());
        physicsCourseResponse.setRoomNum(place.getRoom());
        physicsCourseResponse.setCampusName(place.getCampus());

        return physicsCourseResponse;
    }
}
