package wusthelper.web.api.v2.module.library;

import org.springframework.web.bind.annotation.*;
import wusthelper.web.annotation.RequireToken;
import wusthelper.web.api.v2.TokenTool;
import wusthelper.web.api.v2.code.V2ResponseCode;
import wusthelper.web.response.Response;
import wusthelper.web.service.campus.UserLoginService;

@RequireToken
@RestController
@RequestMapping("/v2/lib")
public class LibraryLoginController {
    private final UserLoginService userLoginService;

    public LibraryLoginController(UserLoginService userLoginService) {
        this.userLoginService = userLoginService;
    }

    @PostMapping("/login")
    public Response<Object> login(@RequestParam("libPwd") String password,
                                  @RequestHeader("Token") String token) {
        String username = TokenTool.getStudentNumber(token);
        userLoginService.login(username, password, UserLoginService.LoginType.Library);

        return Response.success(V2ResponseCode.LIB_LOGIN_SUC.getCode(), null);
    }
}