package wusthelper.web.rpc.http.graduate;

import cn.wustlinghang.mywust.data.global.Course;
import jakarta.validation.constraints.NotNull;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

import java.util.List;

@Component
@FeignClient(name = "wusthelper.graduate", contextId = "graduate-courseTable", url = "http://127.0.0.1:22802")
public interface GraduateCourseTableRemote {
    String ROOT_PATH = "/course_table";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<List<Course>> get(@RequestParam("cookie") String cookie);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("cookie") @NotNull String cookie);

    @PostMapping(ROOT_PATH + "/parse")
    RpcResponseDto<List<Course>> parse(String html);
}
