package wusthelper.web.rpc.http.library;

import cn.wustlinghang.mywust.data.global.Course;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

import java.util.List;
import java.util.Map;

@Component
@FeignClient(name = "wusthelper.library", contextId = "library-bookCoverImage", url = "http://127.0.0.1:22804")
public interface LibraryBookCoverImageRemote {
    String ROOT_PATH = "/cover_image";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<Object> get(@RequestParam("isbn") String isbn);

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<String> agent(@RequestParam("isbn") String isbn);

    @PostMapping(ROOT_PATH + "/batch")
    RpcResponseDto<Map<String, List<String>>> batch(@RequestParam("isbn") String isbnList);
}
