package wusthelper.web.rpc.http.library;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

@Component
@FeignClient(name = "wusthelper.library", contextId = "library-cookie", url = "http://127.0.0.1:22804")
public interface LibraryCookieRemote {
    String COOKIE_ROOT_PATH = "/cookie";

    @GetMapping(COOKIE_ROOT_PATH)
    RpcResponseDto<String> login(@RequestParam("username") String username,
                                 @RequestParam("password") String password);

    @GetMapping(COOKIE_ROOT_PATH + "/verify")
    RpcResponseDto<Boolean> verify(@RequestParam("cookie") String cookie);
}
