package wusthelper.web.rpc.http.library;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.CurrentLoanBook;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

import java.util.List;

@Component
@FeignClient(name = "wusthelper.library", contextId = "library-currentLoan", url = "http://127.0.0.1:22804")
public interface LibraryCurrentLoanRemote {
    String ROOT_PATH = "/current_loan";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<PagingResult<List<CurrentLoanBook>>> get(
            @RequestParam("cookie") String cookie,
            @RequestParam("page") int page,
            @RequestParam("page_ize") int pageSize
    );

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<PagingResult<List<CurrentLoanBook>>> agent(
            @RequestParam("cookie") String cookie,
            @RequestParam("page") int page,
            @RequestParam("page_ize") int pageSize
    );
}
