package wusthelper.web.rpc.http.library;

import cn.wustlinghang.mywust.data.library.PagingResult;
import cn.wustlinghang.mywust.data.library.origin.BookSearchResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import wusthelper.internal.rpc.response.RpcResponseDto;

import java.util.List;

@Component
@FeignClient(name = "wusthelper.library", contextId = "library-search", url = "http://127.0.0.1:22804")
public interface LibrarySearchRemote {
    String ROOT_PATH = "/search";

    @GetMapping(ROOT_PATH)
    RpcResponseDto<PagingResult<List<BookSearchResult>>> get(
            @RequestParam("keyword") String keyword,
            @RequestParam("page") int page,
            @RequestParam("page_ize") int pageSize
    );

    @GetMapping(ROOT_PATH + "/agent")
    RpcResponseDto<PagingResult<List<BookSearchResult>>> agent(
            @RequestParam("keyword") String keyword,
            @RequestParam("page") int page,
            @RequestParam("page_ize") int pageSize
    );
}
