package wusthelper.web.service.campus.graduate;

import cn.wustlinghang.mywust.data.global.Course;
import org.springframework.stereotype.Service;
import wusthelper.code.ServiceCode;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.http.graduate.GraduateCourseTableRemote;
import wusthelper.web.service.cookie.CookieManager;

import java.util.List;

@Service
public class GraduateCourseTableService {
    private final GraduateCourseTableRemote courseTableRemote;

    private final CookieManager cookieManager;

    public GraduateCourseTableService(GraduateCourseTableRemote courseTableRemote, CookieManager cookieManager) {
        this.courseTableRemote = courseTableRemote;
        this.cookieManager = cookieManager;
    }

    public List<Course> getCourseTable(String user) {
        String cookie = cookieManager.getCookie(user, CookieType.Graduate);
        var rpcResp = courseTableRemote.get(cookie);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.error(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
