package wusthelper.web.service.campus.library;

import org.springframework.stereotype.Service;
import wusthelper.code.ServiceCode;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.http.graduate.GraduateCookieRemote;
import wusthelper.web.rpc.http.library.LibraryCookieRemote;

@Service
public class LibraryCookieService {
    private final LibraryCookieRemote libraryCookieRemote;

    public LibraryCookieService(LibraryCookieRemote libraryCookieRemote) {
        this.libraryCookieRemote = libraryCookieRemote;
    }

    public String getLoginCookie(String username, String password) throws ServiceException {
        var rpcResp = libraryCookieRemote.login(username, password);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.error(rpcResp.code());
        }

        return rpcResp.data();
    }

    public Boolean checkCookie(String cookie) {
        return libraryCookieRemote.verify(cookie).data();
    }
}
