package wusthelper.web.service.campus.physics;

import cn.wustlinghang.mywust.data.global.Course;
import cn.wustlinghang.mywust.data.physics.PhysicsCourse;
import org.springframework.stereotype.Service;
import wusthelper.code.ServiceCode;
import wusthelper.web.data.entity.CookieType;
import wusthelper.web.exception.ServiceException;
import wusthelper.web.rpc.http.physics.PhysicsCourseTableRemote;
import wusthelper.web.service.cookie.CookieManager;

import java.util.List;

@Service
public class PhysicsCourseTableService {
    private final PhysicsCourseTableRemote courseTableRemote;

    private final CookieManager cookieManager;

    public PhysicsCourseTableService(PhysicsCourseTableRemote courseTableRemote, CookieManager cookieManager) {
        this.courseTableRemote = courseTableRemote;
        this.cookieManager = cookieManager;
    }

    public List<PhysicsCourse> getCourseTable(String user) {
        String cookie = cookieManager.getCookie(user, CookieType.Physics);
        var rpcResp = courseTableRemote.get(cookie);
        if (rpcResp.code() != ServiceCode.Ok) {
            ServiceException.error(rpcResp.code());
        }

        // todo 异步存用户课表，异常判断等等
        return rpcResp.data();
    }
}
